//
//  WaveformChecker.h
//  Waveform Checker
//
//  Created by Steffen Kamp on Sun Jan 20 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>
#include <CoreServices/CoreServices.h>
#include <stdio.h>
#include <unistd.h>
#include <CoreAudio/CoreAudio.h>
#include <AudioUnit/AudioUnit.h>
#include <AudioToolbox/DefaultAudioOutput.h>

#include <math.h>

#define DO_PRINT 0

#define WAVEFORMLENGTH 8192

#define WFSIN(phase)		sin(phase)
#define WFRECT(phase)		(phase<M_PI?1.:-1.)
#define WFTRIANGLE(phase)	((phase < M_PI_2)?(phase/M_PI_2):((phase < M_PI+M_PI_2)?((phase*-1.)/M_PI_2+2.):((phase)/M_PI_2-4.)))
#define WFSAWTOOTH(phase)	(phase/M_PI-1.)

@interface WaveformChecker : NSObject {
    AudioUnit *theOutputUnit;
    Float32 waveform[WAVEFORMLENGTH];

    float factor;

    id delegate;

    BOOL aboutToStart;
    SInt32 startFrame;
}

- (id)init;
- (void)RenderSinAsIntWithStartingFrameCount:(UInt32)startingFrameCount frames:(UInt32)nFrames buffer:(void*)dataPtr bufferSize:(UInt32)sizeOfData;
OSStatus	MyRenderer(void *inRefCon, AudioUnitRenderActionFlags *ioActionFlags,
                        const AudioTimeStamp *inTimeStamp, UInt32 inBusNumber,
                        UInt32 inNumberFrames, AudioBufferList *ioData);

- (IBAction)start:(id)sender;
- (IBAction)stop:(id)sender;
//- (IBAction)stopOnNextZero:(id)sender;

- (Float32)amplitudeForPhase:(Float32)phase;
- (void)makeStandardSineWave;

- (IBAction)setFactor:(id)sender;
//- (double)getFactorForTime:(double)time;
- (void)setDelegate:(id)delegate;
- (double)factorForTime:(double)time;
//- (double)getPositionForTime:(double)time;
- (double)positionForTime:(double)time;
//- (double)getAmplitudeForTime:(double)t;
- (double)amplitudeForTime:(double)t;

@end
