#import "WaveformView.h"

@implementation WaveformView

- (void)setPointArray:(Float32 *)array count:(int)count {
    pointarray = array;
    pointcount = count;
    [self constructGraph:self];
}

- (IBAction)constructGraph:(id)sender {
    int i;
    NSBezierPath *p = [[NSBezierPath alloc] init];

    [p moveToPoint:NSMakePoint(0., MIN(1., MAX(-1., pointarray[0]))+1.)];

    for(i = 1; i < pointcount; ++i)
        [p lineToPoint:NSMakePoint((float)i, MIN(1., MAX(-1., pointarray[i]))+1.)];

    [path autorelease];
    path = p;

    [self setNeedsDisplay:YES];
}

- (void)drawRect:(NSRect)frame {
    NSAffineTransform *t1 = [NSAffineTransform transform];
    NSAffineTransform *t2 = [NSAffineTransform transform];
    NSSize viewsize = ([self frame]).size;
    [t1 scaleXBy:(viewsize.width-2.)/pointcount yBy:(viewsize.height-2.)/2.];
    [t2 translateXBy:1. yBy:1.];
    [t1 appendTransform:t2];
    [[t1 transformBezierPath:path] stroke];
}
@end
