#import "WaveformViewController.h"

@implementation WaveformViewController

- (id)init {
    self = [super init];
    if(self) {
        [NSBundle loadNibNamed:@"WaveformControl" owner:self];
        delegate = nil;
    }
    return self;
}

- (void)dealloc {
    [view removeFromSuperview];
    [view release];
    [super dealloc];
}

- (IBAction)modifiedAction:(id)sender {
    [self waveformViewControllerDidModify:self];
}

- (void)setDelegate:(id)del {
    delegate = del;
}
- (id)delegate {
    return delegate;
}

- (void)waveformViewControllerDidModify:(WaveformViewController *)v {
    SEL sel = @selector(waveformViewControllerDidModify:);
    if(delegate && [delegate respondsToSelector:sel])
        [delegate performSelector:sel withObject:self];
}

- (WFShape)shape {return [form selectedRow];}
- (double)gain {return [gain doubleValue];}
- (double)phase {return [phase doubleValue];}
- (NSCellStateValue)state {return [state state];}
- (unsigned)wavecount {return [wavecount intValue];}

- (NSView *)view {return view;}

@end
